/*
 * A2V : A2C_Encode.cpp
 *
 * Copyright 1998, Sony Computer Entertainment Inc.
 */

#include "stdafx.h"
#include "A2VDlg.h"

#include "encvag.h"

void CA2VDlg::Encode( CFile& arFp, unsigned long frame, short loopflg, unsigned long loopstart, unsigned long loopend )
{
	unsigned short fcount;
	short i;
	long rest = frame;	/* remain samples */
	unsigned long bsframe = 0;
	short blockRv[BLKSIZ], block[BLKSIZ];
	short outbuf[16];
	short flag;
	CString str = "";


	for( i = 0; i < 16; i++) { /* a block for BRR filter initialize */
		outbuf[i] = 0;
	}

	try{	
		vagFile.Write( outbuf, sizeof( short )* 8 );
	}
	catch(...){			
		throw errStr = "Write error";
		return;
	}

	EncVagInit( ENC_VAG_MODE_NORMAL );

	do { /* BRR convert routine for each 28 samples */
		if( rest <= BLKSIZ ) { /* for last brock */
			for( i = 0; i < BLKSIZ; i++ ) {
				blockRv[i] = 0;
			}
			fcount = (short)rest;
			try{
				arFp.Read( blockRv, sizeof( short )*fcount );
			}
			catch(...){			
				throw errStr = "Error in rading last block of sound data chunk.";
				return;
			}

		} else {
			fcount = BLKSIZ;
			try{
				arFp.Read( blockRv, sizeof( short )*BLKSIZ );
			}
			catch(...){			
				throw errStr = "Error in rading AIFF sound data chunk.";
				return;
			}
		}
		for( i = 0; i < BLKSIZ; i++ ) {
			block[i] = sEndian( blockRv[i] ); /* Invert the endian */
		}
		
#define ENC_VAG_1_SHOT		0
#define ENC_VAG_1_SHOT_END	1
#define ENC_VAG_LOOP_START	2
#define ENC_VAG_LOOP_BODY	3
#define ENC_VAG_LOOP_END	4
		if( loopflg == 1 ) {
			flag = 0;
			if( (loopstart >= bsframe - BLKSIZ) && (loopstart < bsframe ) ) {
				flag = ENC_VAG_LOOP_START;
			} else {
				flag = ENC_VAG_LOOP_BODY;
			}	
			if( (loopend >= bsframe) && (loopend < bsframe + BLKSIZ) ) {
				flag = ENC_VAG_LOOP_END;
				rest = 0;
			}
		} else {
			if( rest <= BLKSIZ ) {
				flag = ENC_VAG_1_SHOT_END;
			} else {
				flag = ENC_VAG_1_SHOT;
			}
		}
		EncVag( block, outbuf, flag );

		try{
			vagFile.Write( outbuf, sizeof( short )* 8 );
		}
		catch(...){			
			throw errStr = "Write error";
			return;
		}
		rest -= BLKSIZ;
		bsframe += BLKSIZ;
	} while( rest > 0 );


	if( loopflg == 0 ) { /* a block for avoiding free run */
		EncVagFin( outbuf );
		try{
			vagFile.Write( outbuf, sizeof( short )* 8 );
		}
		catch(...){			
			throw errStr = "Write error";
			return;
		}
	}

	return;
}

