/*
 * AIFF2VAG : aiff2.h
 *
 * Copyright 1995-1998 Sony Computer Entertainment Inc.
 */


/***********************************************************************************/

#ifdef sony_news
#define sEndian(X) (X)
#define lEndian(X) (X)
#else
#define sEndian(X) ((0xff & (X>>8)) | ((0xff & X) << 8))
#define lEndian(X) (((X >> 24) & 0xff) | ((X >> 8) & 0xff00) | ((X & 0xff00) << 8) | ((X & 0xff) << 24))
#endif

#define AIFF 0x41494646
#define AIFC 0x41494643
#define FVER 0x46564552
#define COMM 0x434f4d4d
#define FORM 0x464f524d
#define SSND 0x53534e44
#define MARK 0x4d41524b
#define INST 0x494e5354
#define MIDI 0x4d494449
#define AESD 0x41455344
#define APPL 0x4150504c
#define COMT 0x434f4d54
#define NAME 0x4e414d45
#define AUTH 0x41555448
#define COPY 0x434f5059
#define ANNO 0x414e4e4f

struct ChunkHeader {
	unsigned long		ckID;
	long						ckSize;
};
typedef struct ChunkHeader ChunkHeader;

struct ChunkAIFFHeader {
	unsigned long		ckID;
	long						ckSize;
	unsigned long		ckType;
};
typedef struct ChunkAIFFHeader ChunkAIFFHeader;


/* Chunk Body Structure */

struct CommonChunk {
	short							numChannels;
	unsigned long					numSampleFrames;
	short							sampleSize;
	unsigned char							sane[10];
/*	char dummy[6]; /* rest of extended80 */
};
typedef struct CommonChunk CommonChunk;

struct Marker {
	short									id;
	unsigned long					position;
	unsigned char							size;
};
typedef struct Marker Marker;

struct SoundDataChunk {
	unsigned long					offset;
	unsigned long					blockSize;
};
typedef struct SoundDataChunk SoundDataChunk;

typedef SoundDataChunk *SoundDataChunkPtr;

/***********************************************************************************/
